## net.sf.saxon.om
Interface NodeInfo

All Superinterfaces:
  Item, javax.xml.transform.Source

All Known Subinterfaces:
  DocumentInfo, SiblingCountingNode

All Known Implementing Classes:
  AbstractNode, DocumentImpl, DocumentWrapper, DocumentWrapper, NamespaceNode, NodeWrapper, NodeWrapper, Orphan, StrippedDocument, StrippedNode, TextFragmentValue, TinyDocumentImpl

public interface NodeInfo
extends javax.xml.transform.Source, Item

A node in the XML parse tree representing an XML element, character content, or attribute. This is the top class in the interface hierarchy for nodes; see NodeImpl for the implementation hierarchy.

Field Summary
`static int` `ALL_NAMESPACES`
`static int` `LOCAL_NAMESPACES`
`static int` `NO_NAMESPACES`

Method Summary
`int` `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
`void` `copy(Receiver out, int whichNamespaces, boolean copyAnnotations, int locationId)` Copy this node to a given outputter
`java.lang.String` `generateId()` Get a character string that uniquely identifies this node.
`java.lang.String` `getAttributeValue(int fingerprint)` Get the value of a given attribute of this node
`java.lang.String` `getBaseURI()` Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
`java.lang.String` `getDisplayName()` Get the display name of this node.
`int` `getDocumentNumber()` Get the document number of the document containing this node.
`DocumentInfo` `getDocumentRoot()` Get the root node, if it is a document node.
`int` `getFingerprint()` Get fingerprint.
`int` `getLineNumber()` Get line number
`java.lang.String` `getLocalPart()` Get the local part of the name of this node.
`int` `getNameCode()` Get name code.
`NamePool` `getNamePool()` Get the NamePool that holds the namecode for this node
`int` `getNodeKind()` Get the kind of node.
`NodeInfo` `getParent()` Get the NodeInfo object representing the parent of this node
`NodeInfo` `getRoot()` Get the root node of the tree containing this node
`java.lang.String` `getStringValue()` Return the string value of the node.
`java.lang.String` `getSystemId()` Get the System ID for the node.
`int` `getTypeAnnotation()` Get the type annotation of this node, if any.
`java.lang.String` `getURI()` Get the URI part of the name of this node.
`boolean` `hasChildNodes()` Determine whether the node has any children.
`boolean` `isSameNodeInfo(NodeInfo other)` Determine whether this is the same node as another node.
`AxisIterator` `iterateAxis(byte axisNumber)` Return an iteration over all the nodes reached by the given axis from this node
`AxisIterator` `iterateAxis(byte axisNumber, NodeTest nodeTest)` Return an iteration over all the nodes reached by the given axis from this node that match a given NodeTest
`void` `outputNamespaceNodes(Receiver out, boolean includeAncestors)` Output all namespace nodes associated with this element.

Methods inherited from interface javax.xml.transform.Source
`setSystemId`

Methods inherited from interface net.sf.saxon.om.Item
`getTypedValue`

Field Detail

### NO_NAMESPACES

    public static final int NO_NAMESPACES

See Also:
  Constant Field Values

### LOCAL_NAMESPACES

    public static final int LOCAL_NAMESPACES

See Also:
  Constant Field Values

### ALL_NAMESPACES

    public static final int ALL_NAMESPACES

See Also:
  Constant Field Values

Method Detail

### getNodeKind

    public int getNodeKind()

  Get the kind of node. This will be a value such as Type.ELEMENT or Type.ATTRIBUTE

  Returns:
    an integer identifying the kind of node. These integer values are the same as those used in the DOM
  See Also:
    `Type`

### isSameNodeInfo

    public boolean isSameNodeInfo(NodeInfo other)

  Determine whether this is the same node as another node. Note: a.isSameNodeInfo(b) if and only if generateId(a)==generateId(b). This method has the same semantics as isSameNode() in DOM Level 3, but works on Saxon NodeInfo objects rather than DOM Node objects.

  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.

### getSystemId

    public java.lang.String getSystemId()

  Get the System ID for the node.

  Specified by:
    `getSystemId` in interface `javax.xml.transform.Source`
  Returns:
    the System Identifier of the entity in the source document containing the node, or null if not known. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot.

### getBaseURI

    public java.lang.String getBaseURI()

  Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node. This will be the same as the System ID unless xml:base has been used.

  Returns:
    the base URI of the node

### getLineNumber

    public int getLineNumber()

  Get line number

  Returns:
    the line number of the node in its original source document; or -1 if not available

### compareOrder

    public int compareOrder(NodeInfo other)

  Determine the relative position of this node and another node, in document order. The other node will always be in the same document.

  Parameters:
    `other` - The other node, whose position is to be compared with this node
  Returns:
    -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

### getStringValue

    public java.lang.String getStringValue()

  Return the string value of the node. The interpretation of this depends on the type of node. For an element it is the accumulated character content of the element, including descendant elements.

  Specified by:
    `getStringValue` in interface `Item`
  Returns:
    the string value of the node

### getNameCode

    public int getNameCode()

  Get name code. The name code is a coded form of the node name: two nodes with the same name code have the same namespace URI, the same local name, and the same prefix. By masking the name code with &0xfffff, you get a fingerprint: two nodes with the same fingerprint have the same local name and namespace URI.

  Returns:
    an integer name code, which may be used to obtain the actual node name from the name pool
  See Also:
    `allocate`, `getFingerprint`

### getFingerprint

    public int getFingerprint()

  Get fingerprint. The fingerprint is a coded form of the expanded name of the node: two nodes with the same name code have the same namespace URI and the same local name. A fingerprint of -1 should be returned for a node with no name.

  Returns:
    an integer fingerprint; two nodes with the same fingerprint have the same expanded QName

### getLocalPart

    public java.lang.String getLocalPart()

  Get the local part of the name of this node. This is the name after the ":" if any.

  Returns:
    the local part of the name. For an unnamed node, returns "". Unlike the DOM interface, this returns the full name in the case of a non-namespaced name.

### getURI

    public java.lang.String getURI()

  Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.

  Returns:
    The URI of the namespace of this node. For an unnamed node, or for a node with an empty prefix, return an empty string.

### getDisplayName

    public java.lang.String getDisplayName()

  Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.

  Returns:
    The display name of this node. For a node with no name, return an empty string.

### getNamePool

    public NamePool getNamePool()

  Get the NamePool that holds the namecode for this node

  Returns:
    the namepool

### getTypeAnnotation

    public int getTypeAnnotation()

  Get the type annotation of this node, if any. Returns -1 for kinds of nodes that have no annotation, and for elements annotated as untyped, and attributes annotated as untypedAtomic.

  Returns:
    the type annotation of the node.
  See Also:
    `Type`

### getParent

    public NodeInfo getParent()

  Get the NodeInfo object representing the parent of this node

  Returns:
    the parent of this node; null if this node has no parent

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber)

  Return an iteration over all the nodes reached by the given axis from this node

  Parameters:
    `axisNumber` - an integer identifying the axis; one of the constants defined in class net.sf.saxon.om.Axis
  Returns:
    an AxisIterator that scans the nodes reached by the axis in turn.
  Throws:
    `java.lang.UnsupportedOperationException` - if the namespace axis is requested and this axis is not supported for this implementation.
  See Also:
    `Axis`

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber,
                                    NodeTest nodeTest)

  Return an iteration over all the nodes reached by the given axis from this node that match a given NodeTest

  Parameters:
    `axisNumber` - an integer identifying the axis; one of the constants defined in class net.sf.saxon.om.Axis
    `nodeTest` - A pattern to be matched by the returned nodes; nodes that do not match this pattern are not included in the result
  Returns:
    a NodeEnumeration that scans the nodes reached by the axis in turn.
  Throws:
    `java.lang.UnsupportedOperationException` - if the namespace axis is requested and this axis is not supported for this implementation.
  See Also:
    `Axis`

### getAttributeValue

    public java.lang.String getAttributeValue(int fingerprint)

  Get the value of a given attribute of this node

  Parameters:
    `fingerprint` - The fingerprint of the attribute name
  Returns:
    the attribute value if it exists or null if not

### getRoot

    public NodeInfo getRoot()

  Get the root node of the tree containing this node

  Returns:
    the NodeInfo representing the top-level ancestor of this node. This will not necessarily be a document node

### getDocumentRoot

    public DocumentInfo getDocumentRoot()

  Get the root node, if it is a document node.

  Returns:
    the DocumentInfo representing the containing document. If this node is part of a tree that does not have a document node as its root, return null.

### hasChildNodes

    public boolean hasChildNodes()

  Determine whether the node has any children.
  Note: the result is equivalent to
  getEnumeration(Axis.CHILD, AnyNodeTest.getInstance()).hasNext()

  Returns:
    True if the node has one or more children

### generateId

    public java.lang.String generateId()

  Get a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)

  Returns:
    a string that uniquely identifies this node, across all documents. (Changed in Saxon 7.5. Previously this method returned an id that was unique within the current document, and the calling code prepended a document id).

### getDocumentNumber

    public int getDocumentNumber()

  Get the document number of the document containing this node. For a free-standing orphan node, just return the hashcode.

### copy

    public void copy(Receiver out,
                     int whichNamespaces,
                     boolean copyAnnotations,
                     int locationId)
              throws XPathException

  Copy this node to a given outputter

  Parameters:
    `out` - the Receiver to which the node should be copied
    `whichNamespaces` - in the case of an element, controls which namespace nodes should be copied. Values are NO_NAMESPACES, LOCAL_NAMESPACES, ALL_NAMESPACES
    `copyAnnotations` - indicates whether the type annotations of element and attribute nodes should be copied
    `locationId` - Identifies the location of the instruction that requested this copy. Pass zero if no other information is available
  Throws:
    `XPathException`

### outputNamespaceNodes

    public void outputNamespaceNodes(Receiver out,
                                     boolean includeAncestors)
                              throws XPathException

  Output all namespace nodes associated with this element. Does nothing if the node is not an element.

  Parameters:
    `out` - The relevant outputter
    `includeAncestors` - True if namespaces declared on ancestor elements must be output; false if it is known that these are already on the result tree
    `XPathException`